﻿<template>
    <v-app>
        <v-container>
            <keep-alive>
                <v-form ref="form"
                        v-model="valid"
                        lazy-validation>
                    <v-select v-model="selectedUserId"
                              :items="usersWithRoles"
                              item-text="userName"
                              item-value="userId"
                              :menu-props="{ maxHeight: '400' }"
                              label="Выберите пользователя"
                              persistent-hint>
                    </v-select>
                    <v-select v-model="selectedRolesArr"
                              :items="roleArr"
                              item-text="name"
                              item-value="name"
                              :menu-props="{ maxHeight: '400' }"
                              label="Выберите роли"
                              multiple
                              persistent-hint></v-select>
                    <v-btn :disabled="!valid"
                           color="success"
                           class="mr-4"
                           @click="onAssignRole">
                        Отправить
                    </v-btn>
                </v-form>
            </keep-alive>
        </v-container>
    </v-app>
</template>

<script>
    import { mapActions, mapGetters } from 'vuex'

    export default {
        data() {
            return {
                valid: true,
                usersWithRoles: [],
                roleArr: [],
                userArr: [],
                selectedRolesArr: [],
                selectedUserId: ""
            }
        },
        created() {
            this.onRolesAll();
            this.onUsersWithRoles();
        },
        computed: {
            ...mapGetters('user', ['getRolesAll', 'getUsersWithRoles']),
        },
        methods: {
            ...mapActions('user', ['onRolesAll', 'onUsersWithRoles']),
            validate() {
                this.$refs.form.validate()
            },
            async onAssignRole() {
                await this.validate()
                if (this.valid === true) {
                    let userId = this.selectedUserId
                    let roles = this.selectedRolesArr
                    this.$store
                        .dispatch('user/roleAssign',
                            {
                                userId,
                                roles
                            }
                        )
                        .then(() => {
                            this.$router.push({ name: 'Home' })
                        })
                        .catch(err => {
                            if (err) {
                                this.userName = '';
                                this.password = '';
                                this.userNameRules = [
                                    v => !!v || 'Неверная почта или пароль'
                                ];
                                this.passwordRules = [
                                    v => !!v || 'Неверная почта или пароль'
                                ];
                            }
                        })
                } else return
            }
        },
        watch: {
            getRolesAll() {
                this.roleArr = this.getRolesAll;
            },
            getUsersWithRoles() {
                this.usersWithRoles = this.getUsersWithRoles;
            },
            selectedUserId() {
                if (this.selectedUserId !== "") {
                    this.selectedRolesArr = [];
                    let user = this.getUsersWithRoles.find(rec => rec.userId === this.selectedUserId);
                    this.selectedRolesArr = user.role;
                }
            }
        }
    }
</script>